package helloagain.kanday;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.KeyStroke;

/**
 * j[o[ƃc[o[T^IȃAvP[VEBhEB
 * <ul>
 * <li>j[o[(KandayMenuBar)
 * <li>c[o[(KandayToolBar)
 * <li>EBhEN[YƃvZXI
 * </ul>
 * <p>
 * Created: Wed May 26 11:42:36 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */
public class KandayFrame extends JFrame {

    /**
     * Ŏw肳ꂽPreferenceɊÂEBhE𐶐B
     * @param aPreferences EBhE̊eݒ
     */
    public KandayFrame(KandayPreferences aPreferences) {
        super(aPreferences.getFrameTitle());
        logger.entering(MYCLASS, "KandayFrame", aPreferences);

        preferences = aPreferences;

        setBounds(
            preferences.getFramePositionX(),
            preferences.getFramePositionY(),
            preferences.getFrameWidth(),
            preferences.getFrameHeight()
        );
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        menuBar = new KandayMenuBar(preferences);
        logger.finest("Created KandayMenuBar");
        toolBar = new KandayToolBar();
        logger.finest("Created KandayToolBar");

        // vOIANV̍쐬
        Icon exitIcon = new ImageIcon(getClass().getResource("Stop16.gif"));
        ExitAction exitAction =
            new ExitAction(preferences.getMenuExit(), exitIcon);
        menuBar.setExitAction(exitAction);
        toolBar.add(exitAction);

        // vt@XҏWANV̍쐬
        Icon preferencesIcon =
            new ImageIcon(getClass().getResource("Preferences16.gif"));
        PreferencesAction preferencesAction = new PreferencesAction(
            preferences.getMenuPreferences(), preferencesIcon
        );
        menuBar.setPreferencesAction(preferencesAction);
        toolBar.add(preferencesAction);

        // o[W\ANV̐
        Icon aboutIcon = new ImageIcon(getClass().getResource("About16.gif"));
        AboutAction aboutAction =
            new AboutAction(preferences.getMenuAbout(), aboutIcon);
        menuBar.setAboutAction(aboutAction);
        toolBar.add(aboutAction);

        // About_CAO̐
        Icon splashIcon = new ImageIcon(getClass().getResource("splash.png"));
        aboutDialog = new KandayAboutDialog(
            this, "About Hello Again", splashIcon,
            preferences.getAboutDescription(),
            preferences.getAboutVersion(),
            preferences.getAboutCopyright()
        );
        // Preferences_CAO̐
        preferencesDialog = new KandayPreferencesDialog(this, preferences);

        pane = new KandayPane();
        setPaneProperties();

        setJMenuBar(menuBar);
        getContentPane().add(toolBar, BorderLayout.NORTH);
        getContentPane().add(pane, BorderLayout.CENTER);
        logger.exiting(MYCLASS, "KandayFrame");
    }

    /**
     * OiF/wiFύXꂽꍇɌĂяo郁\bhB
     * A\pl̐ݒXVčĕ`悷B
     */
    public void updatePreferences() {
        setPaneProperties();
        pane.repaint();
    }

    /**
     * bZ[Wpanȇݒ肷郁\bhB
     */
    private void setPaneProperties() {
        pane.setMessage(preferences.getMessage());
        logger.finer("preferences' foreground=" +
                     preferences.getMessageForegroundColor());
        logger.finer("preferences' background=" +
                     preferences.getMessageBackgroundColor());
        pane.setForeground(preferences.getMessageForegroundColor());
        pane.setBackground(preferences.getMessageBackgroundColor());
        logger.finer("pane's foreground=" + pane.getForeground());
        logger.finer("pane's background=" + pane.getBackground());
    }

    /**
     * vOIANVB
     * ANZ[^EL[ Ctrl-Q ݒ肵A
     * jjbNEL[ X ݒ肵ĂB
     */
    class ExitAction extends AbstractAction {
        ExitAction(String aText) {
            init(aText, null);
        }
        ExitAction(String aText, Icon anIcon) {
            init(aText, anIcon);
        }
        final void init(String aText, Icon anIcon) {
            putValue(NAME, aText);
            putValue(SMALL_ICON, anIcon);
            putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_X));
            putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(
                         KeyEvent.VK_Q, ActionEvent.CTRL_MASK)
            );
            putValue(SHORT_DESCRIPTION,
                     preferences.getMenuExitDescription()
            );
        }
        public void actionPerformed(ActionEvent ev) {
            logger.info("Exit program");
            System.exit(0);
        }
    }

    /**
     * vÕo[W\ANVB
     * jjbNEL[ A ݒ肵ĂB
     */
    class AboutAction extends AbstractAction {
        AboutAction(String aText) {
            init(aText, null);
        }
        AboutAction(String aText, Icon anIcon) {
            init(aText, anIcon);
        }
        final void init(String aText, Icon anIcon) {
            putValue(NAME, aText);
            putValue(SMALL_ICON, anIcon);
            putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_A));
            putValue(SHORT_DESCRIPTION, 
                     preferences.getMenuAboutDescription()
            );
        }
        public void actionPerformed(ActionEvent ev) {
            logger.info("show about dialog");
            aboutDialog.setVisible(true);
        }
    }

    /**
     * vO̐ݒύXANVB
     */
    class PreferencesAction extends AbstractAction {
        PreferencesAction(String aText) {
            init(aText, null);
        }
        PreferencesAction(String aText, Icon anIcon) {
            init(aText, anIcon);
        }
        final void init(String aText, Icon anIcon) {
            putValue(NAME, aText);
            putValue(SMALL_ICON, anIcon);
            putValue(MNEMONIC_KEY, new Integer(KeyEvent.VK_E));
            putValue(SHORT_DESCRIPTION, 
                     preferences.getMenuPreferencesDescription()
            );
        }
        public void actionPerformed(ActionEvent ev) {
            logger.info("edit preferences");
            preferencesDialog.setVisible(true);
        }
    }

    private KandayMenuBar menuBar;
    private KandayToolBar toolBar;
    private KandayPane pane;
    private KandayAboutDialog aboutDialog;
    private KandayPreferences preferences;
    private KandayPreferencesDialog preferencesDialog;

    private static final String MYCLASS = KandayFrame.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
}
