package helloagain.kanday;

import java.awt.Color;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.prefs.Preferences;

/**
 * HelloAgain DesktopvOɂݒ\p[^
 * ێBp[^ĺA\[Xohǂݍ݁A
 * ύXĺAvt@XAPIɂĉiB
 * <p>
 * \[Xoh́Ahelloagain.kandaypbP[W̒ɁA
 * KandayResourceƂ̂ŕێB̓Iɂ͈ȉ̂ǂ炩
 * @Ńp[^lw肷邱Ƃ\B
 * <ol>
 * <li>helloagain.kanday.KandayResource NX݂
 * <li>helloagain/kanday/KandayResource.properties t@C݂
 * </ol>
 * <p>
 * vt@XAPIɂĉi鑮ɂẮA
 * {@link #save} QƁB
 * <p>
 * Created: Wed May 26 12:05:42 2004
 *
 * @author <a href="mailto:torutk@02.246.ne.jp">TAKAHASHI,Toru</a>
 * @version 1.0
 */
public class KandayPreferences {

    /**
     * RXgN^B
     * \[Xohp[^loetB[hɑB
     * ̌A[UEvt@X̒lŃtB[hXVB
     * TODO: \[X݂Ȃƈȉ̗OX[Ă܂
     * @throws java.util.MissingResourceException
     */
    public KandayPreferences() {
        logger.entering(MYCLASS, "KandayPreferences");

        resource = ResourceBundle.getBundle("helloagain.kanday.KandayResource");
        frameTitle = readString(KEY_FRAME_TITLE, "KANDAY");
        frameWidth = readInt(KEY_FRAME_WIDTH, 320);
        frameHeight = readInt(KEY_FRAME_HEIGHT, 200);
        framePositionX = readInt(KEY_FRAME_POSITION_X, 352);
        framePositionY = readInt(KEY_FRAME_POSITION_Y, 284);
        message = readString(KEY_KANDAY_MESSAGE, "Hello world, again!");
        menuFile = readString(KEY_MENU_FILE, "File");
        menuHelp = readString(KEY_MENU_HELP, "Help");
        menuExit = readString(KEY_MENU_EXIT, "Exit");
        menuExitDescriptoin = readString(KEY_MENU_EXIT_DESCRIPTION,
                                         "Exit this program");
        menuAbout = readString(KEY_MENU_ABOUT, "About");
        menuAboutDescription = readString(KEY_MENU_ABOUT_DESCRIPTION,
                                          "About this program");
        menuPreferences = readString(KEY_MENU_PREFERENCES, "Preferences");
        menuPreferencesDescription = readString(
            KEY_MENU_PREFERENCES_DESCRIPTION, "Edit preferences"
        );
        messageBackgroundColor =
            readColor(KEY_MESSAGE_BACKGROUND_COLOR, Color.LIGHT_GRAY);
        messageForegroundColor =
            readColor(KEY_MESSAGE_FOREGROUND_COLOR, Color.DARK_GRAY);
        aboutDescription = readString(
            KEY_ABOUT_DESCRIPTION,
            "Desktop example program by 'Hello Again' project"
        );
        aboutVersion = readString(KEY_ABOUT_VERSION, "Version: Souchong") +
            "(" + getClass().getPackage().getImplementationVersion() +")";

        aboutCopyright = readString(KEY_ABOUT_COPYRIGHT, "(C) TAKAHASHI,Toru");
        preferencesDialogTitle = readString(
            KEY_PREFERENCES_DIALOG_TITLE, "Preferences"
        );
        preferencesDialogFglabelText = readString(
            KEY_PREFERENCES_DIALOG_FGLABEL_TEXT, "Foreground Color:"
        );
        preferencesDialogBglabelText = readString(
            KEY_PREFERENCES_DIALOG_BGLABEL_TEXT, "Background Color:"
        );
        preferencesDialogChangebuttonText = readString(
            KEY_PREFERENCES_DIALOG_CHANGEBUTTON_TEXT, "Change"
        );
        preferencesDialogApplybuttonText = readString(
            KEY_PREFERENCES_DIALOG_APPLYBUTTON_TEXT, "Apply"
        );
        preferencesDialogCancelbuttonText = readString(
            KEY_PREFERENCES_DIALOG_CANCELBUTTON_TEXT, "Cancel"
        );
        preferencesDialogFgcolorchooserTitle = readString(
            KEY_PREFERENCES_DIALOG_FGCOLORCHOOSER_TITLE,
            "Select Foreground Color"
        );
        preferencesDialogBgcolorchooserTitle = readString(
            KEY_PREFERENCES_DIALOG_BGCOLORCHOOSER_TITLE,
            "Select Background Color"
        );
        logger.config("values from resources:" + toString());

        load();
        logger.config("values from user preferences:" + toString());
        logger.exiting(MYCLASS, "KandayPreferences");
    }

    public String toString() {
        return "helloagain.kanday.KandayPreferences[frameTitle=" + frameTitle +
            ",frameWidth=" + frameWidth + ",frameHeight=" + frameHeight +
            ",framePositionX=" + framePositionX + ",framePositionY=" + 
            framePositionY + ",message=" + message + "]";
    }

    /**
     * \[Xw肵L[ɑΉlint^ŎoB
     * @param aKey \[XloۂɎw肷L[
     * @param aDefault w肵L[ɑΉl\[XɌȂ
     *                 ꍇɖ߂lƂĕԋpl
     * @return L[ɑΉl
     */
    private final int readInt(String aKey, int aDefault) {
        if (logger.isLoggable(Level.FINER)) {
            logger.entering(MYCLASS, "readInt", 
                            new Object[]{aKey, new Integer(aDefault)}
            );
        }
        int value = 0;
        try {
            String param = resource.getString(aKey);
            value = Integer.parseInt(param);
        } catch (MissingResourceException e) {
            logger.fine("readInt catching exception:" + e);
            value = aDefault;
        } catch (NumberFormatException e) {
            logger.fine("readInt catching exception:" + e);
            value = aDefault;
        }
        if (logger.isLoggable(Level.FINER)) {
            logger.exiting(MYCLASS, "readInt", new Integer(value));
        }
        return value;
    }

    /**
     * \[Xw肵L[ɑΉlString^ŎoB
     * @param aKey \[XloۂɎw肷L[
     * @param aDefault w肵L[ɑΉl\[XɌȂ
     *                 ꍇɖ߂lƂĕԋpl
     * @return L[ɑΉl
     */
    private final String readString(String aKey, String aDefault) {
        if (logger.isLoggable(Level.FINER)) {
            logger.entering(MYCLASS, "readString",
                            new Object[] {aKey, aDefault}
            );
        }
        String param = null;
        try {
            param = resource.getString(aKey);
        } catch (MissingResourceException e) {
            param = aDefault;
        }
        if (logger.isLoggable(Level.FINER)) {
            logger.exiting(MYCLASS, "readString", param);
        }
        return param;
    }

    /**
     * \[Xw肵L[ɑΉlColor^ŎoB
     * \[Xł́A16i̕ 0xRRGGBBŕ\LB
     *
     * @param aKey \[XloۂɎw肷L[
     * @param aDefault w肵L[ɑΉl\[XɌȂ
     *                 ꍇɖ߂lƂĕԋpl
     * @return L[ɑΉl
     */
    private final Color readColor(String aKey, Color aDefault) {
        if (logger.isLoggable(Level.FINER)) {
            logger.entering(MYCLASS, "readColor",
                            new Object[] {aKey, aDefault}
            );
        }
        Color param = null;
        try {
            param = Color.decode(resource.getString(aKey));
        } catch (MissingResourceException e) {
            param = aDefault;
            logger.warning("not found from resources for key:" + aKey);
        } catch (NumberFormatException e) {
            param = aDefault;
            logger.warning("parsing error from resources for key:" + aKey);
        }
        if (logger.isLoggable(Level.FINER)) {
            logger.exiting(MYCLASS, "readColor", param);
        }
        return param;
    }

    /**
     * EBhẼ^Cgo[ɕ\镶ԋpB
     * @return EBhẼ^Cgo[ɕ\镶
     */
    public String getFrameTitle() {
        return frameTitle;
    }

    /**
     * EBhȆ傫()ԋpB
     * @return EBhE̕[sNZ]
     */
    public int getFrameWidth() {
        return frameWidth;
    }

    /**
     * EBhȆ傫()ݒ肷B
     * @param aWidth EBhE̕[sNZ]
     */
    public void setFrameWidth(int aWidth) {
        frameWidth = aWidth;
    }

    /**
     * EBhȆ傫()ԋpB
     * @return EBhE̍[sNZ]
     */
    public int getFrameHeight() {
        return frameHeight;
    }

    /**
     * EBhȆ傫()ݒ肷B
     * @param aHeight EBhE̍[sNZ]
     */
    public void setFrameHeight(int aHeight) {
        frameHeight = aHeight;
    }

    /**
     * EBhËʒu(XW)ԋpB
     * @return EBhEXW[sNZ]
     */
    public int getFramePositionX() {
        return framePositionX;
    }

    /**
     * EBhËʒu(XW)ݒ肷B
     * @param aX EBhEXW[sNZ]
     */
    public void setFramePositionX(int aX) {
        framePositionX = aX;
    }

    /**
     * EBhËʒu(YW)ԋpB
     * @return EBhEYW[sNZ]
     */
    public int getFramePositionY() {
        return framePositionY;
    }

    /**
     * EBhËʒu(YW)ݒ肷B
     * @param aY EBhEYW[sNZ]
     */
    public void setFramePositionY(int aY) {
        framePositionY = aY;
    }

    /**
     * EBhEɕ\郁bZ[WԋpB
     * @return EBhEɕ\郁bZ[W
     */
    public String getMessage() {
        return message;
    }

    /**
     * Filej[ɕ\镶ԋpB
     * @return Filej[̕
     */
    public String getMenuFile() {
        return menuFile;
    }
    /**
     * Helpj[ɕ\镶ԋpB
     * @return Helpj[̕
     */
    public String getMenuHelp() {
        return menuHelp;
    }
    /**
     * Exitj[ڂɕ\镶ԋpB
     * @return Exitj[ڂ̕
     */
    public String getMenuExit() {
        return menuExit;
    }
    /**
     * Exitj[ڂɑΉANV̐ԋpB
     * c[`bv̕ɎgpB
     * @return ExitANV̐
     */
    public String getMenuExitDescription() {
        return menuExitDescriptoin;
    }

    /**
     * Aboutj[ڂɕ\镶ԋpB
     * @return Aboutj[ڂ̕
     */
    public String getMenuAbout() {
        return menuAbout;
    }
    /**
     * Aboutj[ڂɑΉANV̐ԋpB
     * c[`bv̕ɎgpB
     * @return AboutANV̐
     */
    public String getMenuAboutDescription() {
        return menuAboutDescription;
    }
    /**
     * Preferencesj[ڂɕ\镶ԋpB
     * @return Preferencesj[ڂ̕
     */
    public String getMenuPreferences() {
        return menuPreferences;
    }
    /**
     * Preferencesj[ڂɑΉANV̐ԋpB
     * c[`bv̕ɎgpB
     * @return PreferencesANV̐
     */
    public String getMenuPreferencesDescription() {
        return menuPreferencesDescription;
    }
    /**
     * About_CAOɕ\vO̐ԋpB
     * @return About_CAÕvO̐
     */
    public String getAboutDescription() {
        return aboutDescription;
    }
    /**
     * About_CAOɕ\vÕo[WԋpB
     * @return About_CAÕo[W
     */
    public String getAboutVersion() {
        return aboutVersion;
    }
    /**
     * About_CAOɕ\钘쌠\ԋpB
     * @return About_CAO̒쌠̕
     */
    public String getAboutCopyright() {
        return aboutCopyright;
    }
    /**
     * bZ[W\pl̔wiFԋpB
     * @return bZ[W\pl̔wiF
     */
    public Color getMessageBackgroundColor() {
        return messageBackgroundColor;
    }
    /**
     * bZ[W\pl̔wiFݒ肷B
     * @param aColor bZ[W\pl̔wiF
     */
    public void setMessageBackgroundColor(Color aColor) {
        messageBackgroundColor = aColor;
    }

    /**
     * bZ[W\pl̑OiFԋpB
     * @return bZ[W\pl̑OiF
     */
    public Color getMessageForegroundColor() {
        return messageForegroundColor;
    }
    /**
     * ݒ_CAÕ^CgԋpB
     * @return ݒ_CAÕ^Cg
     */
    public String getPreferencesDialogTitle() {
        return preferencesDialogTitle;
    }
    /**
     * ݒ_CAȎOiFxԋpB
     * @return ݒ_CAȎOiFx
     */
    public String getPreferencesDialogFglabelText() {
        return preferencesDialogFglabelText;
    }
    /**
     * OiFI_CAÕ^CgԋpB
     * @return OiFI_CAÕ^Cg
     */
    public String getPreferencesDialogFgcolorchooserTitle() {
        return preferencesDialogFgcolorchooserTitle;
    }
    /**
     * wiFI_CAÕ^CgԋpB
     * @return wiFI_CAÕ^Cg
     */
    public String getPreferencesDialogBgcolorchooserTitle() {
        return preferencesDialogBgcolorchooserTitle;
    }
    /**
     * ݒ_CAO̔wiFxԋpB
     * @return ݒ_CAO̔wiFx
     */
    public String getPreferencesDialogBglabelText() {
        return preferencesDialogBglabelText;
    }
    /**
     * ݒ_CAO̐FύX{^ԋpB
     * @return ݒ_CAO̕ύX{^
     */
    public String getPreferencesDialogChangebuttonText() {
        return preferencesDialogChangebuttonText;
    }
    /**
     * ݒ_CAO̓Kp{^ԋpB
     * @return ݒ_CAO̓Kp{^
     */
    public String getPreferencesDialogApplybuttonText() {
        return preferencesDialogApplybuttonText;
    }
    /**
     * ݒ_CAO̎{^ԋpB
     * @return ݒ_CAO̎{^
     */
    public String getPreferencesDialogCancelbuttonText() {
        return preferencesDialogCancelbuttonText;
    }

    /**
     * bZ[W\pl̑OiFݒ肷B
     * @param aColor bZ[W\pl̑OiF
     */
    public void setMessageForegroundColor(Color aColor) {
        messageForegroundColor = aColor;
    }

    /**
     * ̒lAPreferences APIpă[UEvt@XƂ
     * obLOXgAɕۑB
     * ݑΏۂ̑
     * <ul>
     * <li>frameWidth
     * <li>frameHeight
     * <li>framePositionX
     * <li>framePositionY
     * <li>messageForegroundColor
     * <li>messageBackgroundColor
     * </ul>
     */
    public void save() {
        logger.entering(MYCLASS, "save");
        Preferences prefs = Preferences.userNodeForPackage(getClass());
        prefs.putInt(KEY_FRAME_WIDTH, frameWidth);
        prefs.putInt(KEY_FRAME_HEIGHT, frameHeight);
        prefs.putInt(KEY_FRAME_POSITION_X, framePositionX);
        prefs.putInt(KEY_FRAME_POSITION_Y, framePositionY);
        prefs.putInt(
            KEY_MESSAGE_FOREGROUND_COLOR, messageForegroundColor.getRGB()
        );
        prefs.putInt(
            KEY_MESSAGE_BACKGROUND_COLOR, messageBackgroundColor.getRGB()
        );
        if (logger.isLoggable(Level.CONFIG)) {
            logger.config(
                "Save to user preferences:[frameWidth=" + frameWidth +
                ",frameHeight=" + frameHeight + ",framePositionX=" +
                framePositionX + ",framePositionY=" + framePositionY +
                ",messageForegroundColor=" + messageForegroundColor.getRGB() + 
                ",messageBackgroundColor=" + messageBackgroundColor.getRGB() +
                "]"
            );
        }
        logger.exiting(MYCLASS, "save");
    }

    /**
     * ̒lAPreferences APIpă[UEvt@XƂ
     * obLOXgA擾B
     */
    public void load() {
        logger.entering(MYCLASS, "load");
        Preferences prefs = Preferences.userNodeForPackage(getClass());
        frameWidth = prefs.getInt(KEY_FRAME_WIDTH, frameWidth);
        frameHeight = prefs.getInt(KEY_FRAME_HEIGHT, frameHeight);
        framePositionX = prefs.getInt(KEY_FRAME_POSITION_X, framePositionX);
        framePositionY = prefs.getInt(KEY_FRAME_POSITION_Y, framePositionY);
        int fgcolorInt = prefs.getInt(
            KEY_MESSAGE_FOREGROUND_COLOR, messageForegroundColor.getRGB()
        );
        messageForegroundColor = new Color(fgcolorInt);
        int bgcolorInt = prefs.getInt(
            KEY_MESSAGE_BACKGROUND_COLOR, messageBackgroundColor.getRGB()
        );
        messageBackgroundColor = new Color(bgcolorInt);
        logger.exiting(MYCLASS, "load");
    }

    private static final String KEY_FRAME_TITLE = "frame.title";
    private static final String KEY_FRAME_WIDTH = "frame.width";
    private static final String KEY_FRAME_HEIGHT = "frame.height";
    private static final String KEY_FRAME_POSITION_X = "frame.position_x";
    private static final String KEY_FRAME_POSITION_Y = "frame.position_y";
    private static final String KEY_KANDAY_MESSAGE = "kanday.message";
    private static final String KEY_MENU_FILE = "menu.file";
    private static final String KEY_MENU_HELP = "menu.help";
    private static final String KEY_MENU_EXIT = "menu.exit";
    private static final String KEY_MENU_EXIT_DESCRIPTION =
        "menu.exit.description";
    private static final String KEY_MENU_ABOUT = "menu.about";
    private static final String KEY_MENU_ABOUT_DESCRIPTION =
        "menu.about.description";
    private static final String KEY_MENU_PREFERENCES = "menu.preferences";
    private static final String KEY_MENU_PREFERENCES_DESCRIPTION = 
        "menu.preferences.description";
    private static final String KEY_ABOUT_DESCRIPTION = "about.description";
    private static final String KEY_ABOUT_VERSION = "about.version";
    private static final String KEY_ABOUT_COPYRIGHT = "about.copyright";
    private static final String KEY_MESSAGE_FOREGROUND_COLOR =
        "message.foreground.color";
    private static final String KEY_MESSAGE_BACKGROUND_COLOR = 
        "message.background.color";
    private static final String KEY_PREFERENCES_DIALOG_TITLE =
        "preferences.dialog.title";
    private static final String KEY_PREFERENCES_DIALOG_FGLABEL_TEXT =
        "preferences.dialog.fglabel.text";
    private static final String KEY_PREFERENCES_DIALOG_BGLABEL_TEXT =
        "preferences.dialog.bglabel.text";
    private static final String KEY_PREFERENCES_DIALOG_CHANGEBUTTON_TEXT =
        "preferences.dialog.changebutton.text";
    private static final String KEY_PREFERENCES_DIALOG_APPLYBUTTON_TEXT =
        "preferences.dialog.applybutton.text";
    private static final String KEY_PREFERENCES_DIALOG_CANCELBUTTON_TEXT =
        "preferences.dialog.cancelbutton.text";
    private static final String KEY_PREFERENCES_DIALOG_FGCOLORCHOOSER_TITLE =
        "preferences.dialog.fgcolorchooser.title";
    private static final String KEY_PREFERENCES_DIALOG_BGCOLORCHOOSER_TITLE =
        "preferences.dialog.bgcolorchooser.title";

    private ResourceBundle resource;

    private String frameTitle;
    private int frameWidth;
    private int frameHeight;
    private int framePositionX;
    private int framePositionY;
    private String message;
    private String menuFile;
    private String menuHelp;
    private String menuExit;
    private String menuExitDescriptoin;
    private String menuAbout;
    private String menuAboutDescription;
    private String menuPreferences;
    private String menuPreferencesDescription;
    private String aboutDescription;
    private String aboutVersion;
    private String aboutCopyright;
    private Color messageForegroundColor;
    private Color messageBackgroundColor;
    private String preferencesDialogTitle;
    private String preferencesDialogFglabelText;
    private String preferencesDialogBglabelText;
    private String preferencesDialogChangebuttonText;
    private String preferencesDialogApplybuttonText;
    private String preferencesDialogCancelbuttonText;
    private String preferencesDialogFgcolorchooserTitle;
    private String preferencesDialogBgcolorchooserTitle;

    // pbP[WƑΉK[擾
    private static String MYCLASS = KandayPreferences.class.getName();
    private static Logger logger = Logger.getLogger(MYCLASS);
}
